// OOTCPApi.h
// definitions needed by an application to use OOTCP's services

#include <rtl_cpp.h>
#include <rtl_fifo.h>

extern "C" {
#include <rtl.h>
}

#define printf rtl_printf

#define ERROR	-1
#define OK		0

class Connection{

public:
	int activeOpen(char * localIP, int localPort, char * remoteIP, int remotePort);
	int passiveOpen(char * localIP, int localPort, int numOfRequests);
	Connection * accept(void);
	int send(char * message, int dataLength);
	int receive(char * buffer, int dataLength);
	char * getLocalIP(void);
	char * getRemoteIP(void);
	int getLocalPort(void);
	int getRemotePort(void);
	int close(void);
};


class ConnectionHandler{

public:
	static Connection * allocate(pthread_t appThread);
	static int deallocate(Connection * con);
	static void printStatus(void);
};
